<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceInterfaceResult_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceInterfaceResult_V4 extends AbstractStructArrayBase
{
    /**
     * The PlaceInterfaceResult_V4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceInterfaceResult_V4[]
     */
    public $PlaceInterfaceResult_V4;
    /**
     * Constructor method for ArrayOfPlaceInterfaceResult_V4
     * @uses ArrayOfPlaceInterfaceResult_V4::setPlaceInterfaceResult_V4()
     * @param \StructType\PlaceInterfaceResult_V4[] $placeInterfaceResult_V4
     */
    public function __construct(array $placeInterfaceResult_V4 = array())
    {
        $this
            ->setPlaceInterfaceResult_V4($placeInterfaceResult_V4);
    }
    /**
     * Get PlaceInterfaceResult_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceInterfaceResult_V4[]|null
     */
    public function getPlaceInterfaceResult_V4()
    {
        return isset($this->PlaceInterfaceResult_V4) ? $this->PlaceInterfaceResult_V4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlaceInterfaceResult_V4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlaceInterfaceResult_V4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlaceInterfaceResult_V4ForArrayConstraintsFromSetPlaceInterfaceResult_V4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlaceInterfaceResult_V4PlaceInterfaceResult_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceInterfaceResult_V4PlaceInterfaceResult_V4Item instanceof \StructType\PlaceInterfaceResult_V4) {
                $invalidValues[] = is_object($arrayOfPlaceInterfaceResult_V4PlaceInterfaceResult_V4Item) ? get_class($arrayOfPlaceInterfaceResult_V4PlaceInterfaceResult_V4Item) : sprintf('%s(%s)', gettype($arrayOfPlaceInterfaceResult_V4PlaceInterfaceResult_V4Item), var_export($arrayOfPlaceInterfaceResult_V4PlaceInterfaceResult_V4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlaceInterfaceResult_V4 property can only contain items of type \StructType\PlaceInterfaceResult_V4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlaceInterfaceResult_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceInterfaceResult_V4[] $placeInterfaceResult_V4
     * @return \ArrayType\ArrayOfPlaceInterfaceResult_V4
     */
    public function setPlaceInterfaceResult_V4(array $placeInterfaceResult_V4 = array())
    {
        // validation for constraint: array
        if ('' !== ($placeInterfaceResult_V4ArrayErrorMessage = self::validatePlaceInterfaceResult_V4ForArrayConstraintsFromSetPlaceInterfaceResult_V4($placeInterfaceResult_V4))) {
            throw new \InvalidArgumentException($placeInterfaceResult_V4ArrayErrorMessage, __LINE__);
        }
        if (is_null($placeInterfaceResult_V4) || (is_array($placeInterfaceResult_V4) && empty($placeInterfaceResult_V4))) {
            unset($this->PlaceInterfaceResult_V4);
        } else {
            $this->PlaceInterfaceResult_V4 = $placeInterfaceResult_V4;
        }
        return $this;
    }
    /**
     * Add item to PlaceInterfaceResult_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceInterfaceResult_V4 $item
     * @return \ArrayType\ArrayOfPlaceInterfaceResult_V4
     */
    public function addToPlaceInterfaceResult_V4(\StructType\PlaceInterfaceResult_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceInterfaceResult_V4) {
            throw new \InvalidArgumentException(sprintf('The PlaceInterfaceResult_V4 property can only contain items of type \StructType\PlaceInterfaceResult_V4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlaceInterfaceResult_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceInterfaceResult_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceInterfaceResult_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceInterfaceResult_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceInterfaceResult_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceInterfaceResult_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceInterfaceResult_V4
     */
    public function getAttributeName()
    {
        return 'PlaceInterfaceResult_V4';
    }
}
